Index: trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/basexecut.cc	(revision 338)
+++ trunk/SophyaPI/PIext/basexecut.cc	(revision 339)
@@ -286,5 +286,7 @@
   }
 
+// Obsolete : ne pas virer SVP, cmv 26/7/99
 else if (kw == "gfd2d") {
+  cout<<"----- gfd2d OBSOLETE: utilisez nt2d -----"<<endl;
   if(tokens.size()<2)
     {cout<<"Usage: gfd2d nomobj numvarx erreur=(x y xy) opt"<<endl;
@@ -298,4 +300,5 @@
   }
 else if (kw == "gfd3d") {
+  cout<<"----- gfd3d OBSOLETE: utilisez nt3d -----"<<endl;
   if(tokens.size()<3)
     {cout<<"Usage: gfd3d nameobj numvarx numvary erreur=(x y z xy xz yz xyz) opt"<<endl;
@@ -710,9 +713,13 @@
 usage += "\n Usage : nt3d nameobj varx vary varz [errx erry errz] [graphic_attributes]";
 usage += "\n  Related commands: disp  surf  nt2d nt2dw  gfd3d ";  
+usage += "\n  Related commands: disp  surf  nt2d nt2dw ";  
 mpiac->RegisterCommand(kw, usage, this, "Obj. Display");
+
+// Ceci est maintenant obsolete, on garde pour info.
 kw = "gfd2d";
 usage = "Displays Points (X-Y) with error-bars from a GeneralFit Data ";
 usage += "\n Usage : gfd2d nameobj numvarx erreur=(x y xy) [graphic_attributes]";
-usage += "\n  Related commands: gfd3d nt2d nt3d ";  
+usage += "\n  Related commands: gfd3d nt2d nt3d ";
+usage += "\n  ----- OBSOLETE: utilisez nt2d -----";
 mpiac->RegisterCommand(kw, usage, this, "Obj. Display");
 kw = "gfd3d";
@@ -720,4 +727,5 @@
 usage += "\n Usage : gfd3d nameobj numvarx numvary erreur=(x y z xy xz yz xyz) [graphic_attributes]";
 usage += "\n  Related commands: gfd2d nt2d nt3d ";  
+usage += "\n  ----- OBSOLETE: utilisez nt3d -----";
 mpiac->RegisterCommand(kw, usage, this, "Obj. Display");
 
@@ -819,5 +827,4 @@
 mpiac->RegisterCommand(kw, usage, this, "Expr. Plotting");
 
-
 }
 
Index: trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.cc	(revision 338)
+++ trunk/SophyaPI/PIext/nobjmgr.cc	(revision 339)
@@ -925,5 +925,5 @@
 }
 
-/* --Methode-- cmv 13/10/98 */
+/* --Methode-- cmv 13/10/98 : Obsolete mais ne pas virer SVP */
 void NamedObjMgr::DisplayGFD(string& nom, string& numvarx, string& numvary, string& err, string dopt)
 //	Pour le display 2D ou 3D d'un ``GeneralFitData''.
@@ -961,15 +961,15 @@
 }
 // Decodage des numeros de variables en abscisse
-int numvx=-1, numvy=-1;
-if(numvarx.length()>0) numvx = atoi(numvarx.c_str());
-if(numvary.length()>0) numvy = atoi(numvary.c_str());
-
-int wrsid = 0;
-if(numvy>=0) {              // Display 3D
+ int numvx=-1, numvy=-1;
+ if(numvarx.length()>0) numvx = atoi(numvarx.c_str());
+ if(numvary.length()>0) numvy = atoi(numvary.c_str());
+ 
+ int wrsid = 0;
+ if(numvy>=0) {              // display 3D
   PIGenFitDat3D* pigfd = new PIGenFitDat3D(((GeneralFitData*)obj),false);
   pigfd->SelectXY(numvx,numvy);
   pigfd->SelectErrBar(errx,erry,errz);
   wrsid = myImgApp->Disp3DDrawer(pigfd,nom,opt);  
-} else {                   // Display 2D
+} else {                   // display 2D
   PIGenFitDat* pigfd = new PIGenFitDat(((GeneralFitData*)obj),false);
   pigfd->SelectX(numvx);
Index: trunk/SophyaPI/PIext/nomgfdadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomgfdadapter.cc	(revision 339)
+++ trunk/SophyaPI/PIext/nomgfdadapter.cc	(revision 339)
@@ -0,0 +1,94 @@
+#include "machdefs.h"
+#include <stdlib.h>
+#include <typeinfo>
+#include <iostream.h>
+#include <string>
+
+#include "nomgfdadapter.h"
+#include "pipodrw.h"
+
+//-------------------------------------------------------------------------
+// Class Adaptateur d'objet (Pour NamedObjMgr) d'objet GeneralFitData
+//-------------------------------------------------------------------------
+
+/* --Methode-- */
+NOMAdapter_GeneralFitData::NOMAdapter_GeneralFitData(GeneralFitData* o)
+  : NObjMgrAdapter(o)
+{
+mG = o;
+}
+
+/* --Methode-- */
+NOMAdapter_GeneralFitData::~NOMAdapter_GeneralFitData()
+{
+}
+
+/* --Methode-- */
+NObjMgrAdapter* NOMAdapter_GeneralFitData::Clone(AnyDataObj* o)
+{
+GeneralFitData* g = dynamic_cast<GeneralFitData *>(o);
+if (g) return ( new NOMAdapter_GeneralFitData(g) );
+return ( new NObjMgrAdapter(o) );
+}
+
+/* --Methode-- */
+void NOMAdapter_GeneralFitData::SavePPF(POutPersist& pos, string const & nom)
+{
+#ifdef SANS_EVOLPLANCK
+// PEIDA-EROS L'histo est lui-meme PPersist
+string tag = nom;  // A cause de const
+mG->Write(pos,0,tag);
+#else
+string s = typeid(*mObj).name();
+cout<<"NOMAdapter_GeneralFitData::SavePPF() - Error : Not supported for "<<s<<endl;
+#endif
+}
+
+/* --Methode-- */
+void NOMAdapter_GeneralFitData::Print(ostream& os)
+{
+os << *(mG);
+}
+
+/* --Methode-- */
+NTupleInterface* NOMAdapter_GeneralFitData::GetNTupleInterface()
+{
+return( new NTupInt_GeneralFitData(mG) );
+}
+
+// -------------------------------------------------------------
+
+/* --Methode-- */
+NTupInt_GeneralFitData::NTupInt_GeneralFitData(GeneralFitData* g)
+{
+mG = g;
+}
+
+/* --Methode-- */
+NTupInt_GeneralFitData::~NTupInt_GeneralFitData()
+{
+}
+
+/* --Methode-- */
+uint_4 NTupInt_GeneralFitData::NbLines() const 
+{
+return(mG->NbLines());
+}
+
+/* --Methode-- */
+uint_4 NTupInt_GeneralFitData::NbColumns() const 
+{
+return(mG->NbColumns());
+}
+
+/* --Methode-- */
+r_8* NTupInt_GeneralFitData::GetLineD(int n) const 
+{
+return(mG->GetLineD(n));
+}
+
+/* --Methode-- */
+string NTupInt_GeneralFitData::VarList_C(const char* nx) const 
+{
+return(mG->VarList_C(nx));
+}
Index: trunk/SophyaPI/PIext/nomgfdadapter.h
===================================================================
--- trunk/SophyaPI/PIext/nomgfdadapter.h	(revision 339)
+++ trunk/SophyaPI/PIext/nomgfdadapter.h	(revision 339)
@@ -0,0 +1,45 @@
+// This may look like C code, but it is really -*- C++ -*-
+// Adaptateur d objets (pour NamedObjMgr) pour GeneralFitData
+//                                    cmv 27/7/99
+//  LAL-IN2P3/CNRS               CEA-DAPNIA     
+ 
+#ifndef NOMGFDADAPTER_H_SEEN
+#define NOMGFDADAPTER_H_SEEN
+
+#include "nomgadapter.h"
+#include "generaldata.h"
+
+//-------------------------------------------------------------------------
+// Class Adaptateur d'objet (Pour NamedObjMgr) d'objet GeneralFitData 
+//-------------------------------------------------------------------------
+
+class NOMAdapter_GeneralFitData : public NObjMgrAdapter {
+public:
+			   NOMAdapter_GeneralFitData(GeneralFitData* o = NULL);
+  virtual		   ~NOMAdapter_GeneralFitData();
+
+  virtual NObjMgrAdapter*  Clone(AnyDataObj* o);
+
+  virtual void		   SavePPF(POutPersist& s, string const & nom);
+
+  virtual void		   Print(ostream& os);
+  virtual NTupleInterface* GetNTupleInterface();
+
+protected:
+  GeneralFitData* mG;
+};
+
+// Class Interface GeneralFitData pour GeneralFitData 
+class NTupInt_GeneralFitData : public NTupleInterface {
+public:
+		  NTupInt_GeneralFitData(GeneralFitData* g);
+  virtual	  ~NTupInt_GeneralFitData();
+  virtual uint_4  NbLines() const ;
+  virtual uint_4  NbColumns() const ;
+  virtual r_8 *   GetLineD(int n) const ;
+  virtual string  VarList_C(const char* nomx=NULL) const ;
+protected:
+  GeneralFitData* mG;
+};
+
+#endif
Index: trunk/SophyaPI/PIext/pigfd1.cc
===================================================================
--- trunk/SophyaPI/PIext/pigfd1.cc	(revision 338)
+++ trunk/SophyaPI/PIext/pigfd1.cc	(revision 339)
@@ -1,2 +1,4 @@
+// Cette classe est maintenant obsolete: generaldata <==> ntuple pour le dessin
+
 #include <stdio.h>
 #include "pigfd1.h"
@@ -41,6 +43,6 @@
 double dx, dy;
 double xmin=9.e19, xmax=-9.e19, ymin=9.e19, ymax=-9.e19;
-mGFD->GetMinMax(10*VarX+2,xmin,xmax);
-mGFD->GetMinMax(0,ymin, ymax);
+mGFD->GetMnMx(10*VarX+2,xmin,xmax);
+mGFD->GetMnMx(0,ymin, ymax);
 if(xmax<=xmin) xmax = xmin+1.;
 if(ymax<=ymin) ymax = ymin+1.;
Index: trunk/SophyaPI/PIext/pigfd1.h
===================================================================
--- trunk/SophyaPI/PIext/pigfd1.h	(revision 338)
+++ trunk/SophyaPI/PIext/pigfd1.h	(revision 339)
@@ -1,2 +1,4 @@
+// Cette classe est maintenant obsolete: generaldata <==> ntuple pour le dessin
+
 #ifndef PIGFD1_H
 #define PIGFD1_H
@@ -24,2 +26,3 @@
 
 #endif
+
Index: trunk/SophyaPI/PIext/pigfd2.cc
===================================================================
--- trunk/SophyaPI/PIext/pigfd2.cc	(revision 338)
+++ trunk/SophyaPI/PIext/pigfd2.cc	(revision 339)
@@ -1,2 +1,4 @@
+// Cette classe est maintenant obsolete: generaldata <==> ntuple pour le dessin
+
 #include <stdio.h>
 #include "pigfd2.h"
@@ -41,7 +43,7 @@
 if(VarX<0 || VarY<0) return;
 double xmin=9.e19, xmax=-9.e19, ymin=9.e19, ymax=-9.e19, zmin=9.e19, zmax=-9.e19;
-mGFD->GetMinMax(10*VarX+2,xmin,xmax);
-mGFD->GetMinMax(10*VarY+2,ymin,ymax);
-mGFD->GetMinMax(0,zmin, zmax);
+mGFD->GetMnMx(10*VarX+2,xmin,xmax);
+mGFD->GetMnMx(10*VarY+2,ymin,ymax);
+mGFD->GetMnMx(0,zmin, zmax);
 if(xmax<=xmin) xmax = xmin+1.;
 if(ymax<=ymin) ymax = ymin+1.;
@@ -103,2 +105,3 @@
 return;
 }
+
Index: trunk/SophyaPI/PIext/pigfd2.h
===================================================================
--- trunk/SophyaPI/PIext/pigfd2.h	(revision 338)
+++ trunk/SophyaPI/PIext/pigfd2.h	(revision 339)
@@ -1,2 +1,4 @@
+// Cette classe est maintenant obsolete: generaldata <==> ntuple pour le dessin
+
 #ifndef PIGFD2_H
 #define PIGFD2_H
@@ -25,2 +27,3 @@
 
 #endif
+
Index: trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- trunk/SophyaPI/PIext/piinit.cc	(revision 338)
+++ trunk/SophyaPI/PIext/piinit.cc	(revision 339)
@@ -4,4 +4,5 @@
 #include "servnobjm.h"
 #include "nomhistadapter.h"
+#include "nomgfdadapter.h"
 #include "nommatvecadapter.h"
 #include "nomimagadapter.h"
@@ -23,4 +24,6 @@
   serv->RegisterClass(new NTuple, new NOMAdapter_NTuple );
 
+  serv->RegisterClass(new GeneralFitData, new NOMAdapter_GeneralFitData );
+
   serv->RegisterClass(new Vector, new NOMAdapter_Vector );
   serv->RegisterClass(new Matrix, new NOMAdapter_Matrix );
@@ -30,5 +33,5 @@
   serv->RegisterClass(new Image<int_4>, new  NOMAdapter_Image<int_4> );
   serv->RegisterClass(new Image<r_4>, new  NOMAdapter_Image<r_4> );
-  
+ 
   serv->RegisterClass(new FitsImage<uint_2>, new  NOMAdapter_Image<uint_2> );
   serv->RegisterClass(new FitsImage<int_2>, new  NOMAdapter_Image<int_2> );
@@ -37,6 +40,6 @@
 
   serv->RegisterClass(new StarList, new NOMAdapter_StarList );
-  
-} 
+
+}
 
 PIAppInitiator::~PIAppInitiator()