Index: trunk/Poubelle/archTOI.old/archeopsfile.cc
===================================================================
--- trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 345)
+++ trunk/Poubelle/archTOI.old/archeopsfile.cc	(revision 346)
@@ -776,14 +776,4 @@
   if (!lastGPS()) return -9.e99;
   return blockSet->gpsParser.getUTC();
-/*  char* p = lastGPS()->gps;
-  //if (strncmp(p, "$GPGGA,", 7)) return -9.e99;
-  //p += 7;
-  if (*p != '$') return -9.e99;
-  p += 1;
-  double t;
-  sscanf(p, "%lg", &t);
-  int h = int(t/10000); t -= h*10000;
-  int m = int(t/100);   t -= m*100;
-  return h*3600. + m*60. + t;*/
 }
 
@@ -801,21 +791,4 @@
   if (!lastGPS()) return -9.e99;
   return blockSet->gpsParser.getLatitude();
-  /*char* p = lastGPS()->gps;
-  //if (strncmp(p, "$GPGGA,", 7)) return -9.e99;
-  if (*p!='$') return -9.e99;
-  char* fence = p+80;
-  p += 1;
-  while (*p != ',' && p<fence) p++;
-  if (*p != ',') return -9.e99; 
-  p++;
-  double t;
-  sscanf(p, "%lg", &t);
-  int d = int(t/100); t -= d*100;
-  t = d + t/60;
-  while (*p != ',' && p<fence) p++;
-  if (*p != ',') return -9.e99; 
-  p++;
-  if (*p == 'S') t = -t;
-  return t;*/
 }
 
@@ -824,23 +797,4 @@
   if (!lastGPS()) return -9.e99;
   return blockSet->gpsParser.getLongitude();
-  /*char* p = lastGPS()->gps;
-  //if (strncmp(p, "$GPGGA,", 7)) return -9.e99;
-  if (*p!='$') return -9.e99;
-  char* fence = p+80;
-  p += 1;
-  for (int i=0; i<3; i++) {
-    while (*p != ',' && p<fence) p++;
-    if (*p != ',') return -9.e99; 
-    p++;
-  }
-  double t;
-  sscanf(p, "%lg", &t);
-  int d = int(t/100); t -= d*100;
-  t = d + t/60;
-  while (*p != ',' && p<fence) p++;
-  if (*p != ',') return -9.e99; 
-  p++;
-  if (*p == 'W') t = -t;
-  return t;*/
 }
 
@@ -848,17 +802,4 @@
   if (!lastGPS()) return -9.e99;
   return blockSet->gpsParser.getAltitude();
-  /*char* p = lastGPS()->gps;
-  //if (strncmp(p, "$GPGGA,", 7)) return -9.e99;
-  if (*p!='$') return -9.e99;
-  char* fence = p+80;
-  p += 1;
-  for (int i=0; i<8; i++) {
-    while (*p != ',' && p<fence) p++;
-    if (*p != ',') return -9.e99; 
-    p++;
-  }
-  double t;
-  sscanf(p, "%lg", &t);
-  return t;*/
 }
 
@@ -890,6 +831,6 @@
   if (!blk) return 0;
   block_type_reglage* reglage = lastReglage();
-  block_type_param* param = lastParam();
-  
+  if (!reglage) return 0;
+
   nb_coups= reglage->reglage.horloge.nb_mesures/2 - reglage->reglage.horloge.temp_mort;
   aa = (nb_coups<<14) + (nb_coups*190) ;
@@ -909,4 +850,6 @@
   block_type_reglage* reglage = lastReglage();
   block_type_param*   param = lastParam();
+  if (!reglage) return 0;
+  if (!param) return 0;
   //cout << "muv " << imesure << " " << y << "\n";
   return bol_micro_volt(y,(double)param->param.bolo[ibolo].bolo_gain*gain_ampli(reglage->reglage.bolo[ibolo]));
Index: trunk/Poubelle/archTOI.old/gpsparser.cc
===================================================================
--- trunk/Poubelle/archTOI.old/gpsparser.cc	(revision 345)
+++ trunk/Poubelle/archTOI.old/gpsparser.cc	(revision 346)
@@ -63,14 +63,14 @@
 // $104020,3740.712,N,00400.781,W,0,00,01.0,0003,M,-050,M,,
 
-#include <fstream.h>
-#include <iomanip.h>
-ofstream gpsdump("gpsdump");
-ofstream gpsdata("gpsdata");
-double outc = 0; double jr = 0;
+//#include <fstream.h>
+//#include <iomanip.h>
+//ofstream gpsdump("gpsdump");
+//ofstream gpsdata("gpsdata");
+//double outc = 0; double jr = 0;
 
 void GPSParser::ProcessBlock(block_type_gps* blk) {
   strncpy(gpsString, blk->gps, 80);
   char* p = gpsString;
-  gpsdump << p ; if (p[strlen(p)-1] != '\n') gpsdump << '\n';
+ // gpsdump << p ; if (p[strlen(p)-1] != '\n') gpsdump << '\n';
   char* fence = p+80;
   stringOk = false;
@@ -154,7 +154,7 @@
   if (*p != 'M') return; 
 
-  if (gpsutc < outc) jr += 86400; 
-  outc = gpsutc;
-  gpsdata << setprecision(10) << gpsutc + jr << " " << gpslat << " " << gpslong << " " << quality << " " << nsat << '\n';
+  //if (gpsutc < outc) jr += 86400; 
+  //outc = gpsutc;
+  //gpsdata << setprecision(10) << gpsutc + jr << " " << gpslat << " " << gpslong << " " << quality << " " << nsat << '\n';
 
   stringOk = true;